#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
    int n;
    cin>>n;
    vector <int> delioci;
    for(int i=1;i*i<n;i++){
        if(n%i==0)
            delioci.push_back(i);
        if(i!=n/i)
            delioci.push_back(n/i);
    }
    sort(delioci.begin(),delioci.end());
    int xorg=0;
    for(int d:delioci)
        xorg=xorg^d;
    cout<<xorg;
    for(int d:delioci){
        int x=0;
        for(int j=1;j*j<d;j++){
            if(d%j==0){
                x=x^j;
                if(j!=d/j)
                    x=x^(d/j);
            }

        cout<<x<<" "<<;
    }

    return 0;
}}